
using System;
using System.Data.SQLite;

namespace Dizzy
{


	public class GlobalConfig
	{
		public string user, password;
		private SQLiteConnection conn;
		
		public GlobalConfig ()
		{
			conn = new SQLiteConnection ("Data Source=" + DataBaseName () + ";Version=3;");
			// Controlliamo che il database sia correttamente
			// inizializzato. 
			Init ();
		}
		
		protected void Init ()
		{
			SQLiteCommand sqlCmd;
			this.conn.Open ();
			sqlCmd = this.conn.CreateCommand ();
			
			sqlCmd.CommandText = "SELECT * from sqlite_master WHERE type='table';";
			SQLiteDataReader reader = sqlCmd.ExecuteReader ();
			
			if(!reader.HasRows)
				InitialSetup ();
		}
		
		protected void InitialSetup ()
		{
			
		}
		
		protected string DataBaseName ()
		{
			string dir = "";
			if (System.Environment.OSVersion.ToString ().Contains("Windows"))
			{
				
				System.Reflection.Assembly a = System.Reflection.Assembly.GetEntryAssembly ();
				dir = System.IO.Path.GetDirectoryName (a.Location);
				
			}
			else // Assumiamo qualcosa di Unix-like
			{
				dir = System.Environment.GetEnvironmentVariable("HOME");
				dir += System.IO.Path.DirectorySeparatorChar + ".dizzy";
			}
			if (!System.IO.Directory.Exists(dir))
				System.IO.Directory.CreateDirectory (dir);
			
			string db = dir + System.IO.Path.DirectorySeparatorChar + "list.sqlite";
			if (!System.IO.File.Exists (db))
				System.IO.File.Create (db);
			return db;
		}
	}
	
}
